// Copyright © Amazon Web Services
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.opengroup.osdu.notification.provider.aws.utils;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;
import static org.mockito.ArgumentMatchers.any;
import static org.mockito.Mockito.when;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import com.amazonaws.services.cognitoidp.AWSCognitoIdentityProvider;
import com.amazonaws.services.sqs.AmazonSQS;

import io.jsonwebtoken.lang.Assert;

//@RunWith(MockitoJUnitRunner.class)
public class AwsCognitoClientTest {
    /*
	private AwsCognitoClient awsCognitoClient;

	@Mock
	private AmazonSQS sqsClient;

	@Mock
	private AWSCognitoIdentityProvider provider;

	@Before
	public void setUp() {
		awsCognitoClient = new AwsCognitoClient("region", "awsCognitoClientId", "awsCognitoAuthFlow",
				"awsCognitoAuthParamsUser", "awsCognitoAuthParamsPassword");
	}

	@Test
	public void constuctorCreatesObject() {
		Assert.isInstanceOf(AwsCognitoClient.class, awsCognitoClient);
		assertNotNull(awsCognitoClient);
	}

	@Test
	public void getToken() {
		awsCognitoClient.provider = provider;
		when(provider.initiateAuth(any())).thenReturn(null);
		String expected = "";
		String actual = awsCognitoClient.getToken("username", "password", "tokenType");
		assertEquals(expected, actual);
	}
	
	@Test
	public void getProvider() {
		AWSCognitoIdentityProvider object = awsCognitoClient.getProvider();
		assertTrue(object instanceof AWSCognitoIdentityProvider);
	}
	
	@Test
	public void generateCognitoClient() {
		AWSCognitoIdentityProvider object = awsCognitoClient.generateCognitoClient("us-east-1");
		assertTrue(object instanceof AWSCognitoIdentityProvider);
	}
	
	//the code on production side seems useless. hence useless test here just for coverage.
	@Test
	public void setPassword() {
		awsCognitoClient.provider = provider;
		when(provider.adminSetUserPassword(any())).thenReturn(null);
		awsCognitoClient.setPassword("username", "password", "user-pool-id");
		assertNotNull(awsCognitoClient);
	} */
}
